
%Dynare placed the estimated ('smoothed') output gap in oo_.SmoothedVariables.x
tt=1:length(oo_.PosteriorSmoothedVariables.Median.x);

%load up the data, including the actual output gap, which is in x
datapullcgg

%get the level of actual output
y=cumsum(dy);
y=y([first_:first_+num_-1]);

%HP filter actual output (ytrend - the HP trend, ycycle - the HP cycle)
[ycycle,ytrend]=HPFAST(y,1600);

subplot(211)
plot(tt,y,tt,ytrend,'x-')
legend('actual output','HP trend output')
axis tight

subplot(212)
plot(tt,ycycle,tt,x([first_:first_+num_-1]),'-o',tt,oo_.PosteriorSmoothedVariables.Median.x,'*-')
legend('HP filtered estimate of gap','Actual gap','DSGE-based Estimate of Gap')
axis tight

figure

plot(tt,oo_.PosteriorSmoothedVariables.Median.x,'x-','LineWidth',2,'Color',[.6 0 0])
hold on
plot(tt,oo_.PosteriorSmoothedVariables.HPDinf.x,tt,oo_.PosteriorSmoothedVariables.HPDsup.x)
hold on
plot(tt,x([first_:first_+num_-1]),'*-','Color','b','LineWidth',2)
legend('Median estimate of output gap','upper 95% probability interval','lower 95% probability interval','actual data')
axis tight
title('Comparison of Actual and DSGE-Based Estimated Output Gap','FontSize',18)

figure
subplot(211)
plot(tt,oo_.PosteriorFilteredVariables.Median.x,'x-','LineWidth',2,'Color',[.6 0 0])
hold on
plot(tt,x([first_:first_+num_-1]),'*-','Color','b','LineWidth',3)
legend('Median estimate of output gap','Actual output gap')
axis tight
title('Comparison of Actual and ''Real-time'' DSGE-Based Estimated Output Gap','FontSize',18)
subplot(212)
plot(tt,x([first_:first_+num_-1])-oo_.PosteriorFilteredVariables.Median.x)
title('Actual output gap minus ''real-time'' estimate','FontSize',18)
axis tight

figure 

yyc=zeros(num_,1);
yy=y([1:2]);
[yycycle,yytrend]=HPFAST(yy,1600);
yyc=yycycle;
for ii = 3:num_
    yy=y([1:ii]);
    [yycycle,yytrend]=HPFAST(yy,1600);
    yyc(ii)=yycycle(ii);
end

plot(tt,yyc,tt,x([first_:first_+num_-1]),'-o',tt,oo_.PosteriorFilteredVariables.Median.x,'*-')
legend('''Real time'' HP filtered estimate of gap','Actual gap','''Real-time DSGE-based estimate of output gap')
axis tight

figure
tf=[tt(end)+1:tt(end)+12];
subplot(211)
plot(tt,dy([first_:first_+num_-1]),tf,oo_.Forecast.Median.dy,'x-',tf,oo_.Forecast.HPDTotalinf.dy,'*-',tf,oo_.Forecast.HPDTotalsup.dy,'*-')
legend('Actual data','median forecast','95% confidence interval')
title('output growth')
subplot(212)
plot(tt,pie([first_:first_+num_-1]),tf,oo_.Forecast.Median.pie,'x-',tf,oo_.Forecast.HPDTotalinf.pie,'*-',tf,oo_.Forecast.HPDTotalsup.pie,'*-')
title('inflation')  
str='Forecasts of inflation and output growth';
hout=suptitle(str);
